## frama-c 20081201.dfsg

=== src/dummy/hello_world/Makefile ===
# Generic Makefile for bytecode plugins

FRAMAC_SHARE=$(shell frama-c -print-path)
PLUGIN_NAME=hello
PLUGIN_SRC=hello_world.ml

include $(FRAMAC_SHARE)/Makefile.template
