=== src/dummy/untyped_metrics/Makefile ===
# Generic Makefile for bytecode plugins

FRAMAC_SHARE=/usr/local/share/frama-c

PLUGIN_NAME=untyped_metrics
PLUGIN_SRC=count_for.ml

include $(FRAMAC_SHARE)/Makefile.template
