## frama-c 20090902+beryllium+dfsg

=== Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2009                                               #
#    CEA   (Commissariat  l'nergie Atomique)                           #
#    INRIA (Institut National de Recherche en Informatique et en         #
#           Automatique)                                                 #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version v2.1                #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# This file is the main makefile of Frama-C.

MAKECONFIG_DIR=share

include share/Makefile.common

###########################
# Global plugin variables #
###########################

# the directory where compiled plugin files are stored
PLUGIN_LIB_DIR	= lib/plugins
PLUGIN_GUI_LIB_DIR= lib/gui

# the directory where the other Makefiles are
FRAMAC_SHARE	= share

# set it to yes to tell Makefile.dynamic than we come from here
FRAMAC_MAKE	=yes

# Shared lists between Makefile.plugin and Makefile :
# initialized them as "simply extended variables" (with :=)
# for a correct behavior of += (see section 6.6 of GNU Make manual)
PLUGIN_LIST	:=
PLUGIN_DYN_EXISTS:="no"
PLUGIN_DYN_LIST :=
PLUGIN_CMO_LIST	:=
PLUGIN_CMX_LIST	:=
PLUGIN_DYN_CMO_LIST :=
PLUGIN_DYN_CMX_LIST :=
PLUGIN_INTERNAL_CMO_LIST:=
PLUGIN_INTERNAL_CMX_LIST:=
PLUGIN_DEP_GUI_CMO_LIST:=
PLUGIN_DEP_GUI_CMX_LIST:=
PLUGIN_GUI_CMO_LIST:=
PLUGIN_GUI_CMX_LIST:=
PLUGIN_DYN_DEP_GUI_CMO_LIST:=
PLUGIN_DYN_DEP_GUI_CMX_LIST:=
PLUGIN_DYN_GUI_CMO_LIST :=
PLUGIN_DYN_GUI_CMX_LIST :=
PLUGIN_TYPES_CMO_LIST :=
PLUGIN_TYPES_CMX_LIST :=
PLUGIN_GENERATED_LIST :=
PLUGIN_DEP_LIST:=
PLUGIN_DOC_LIST :=
PLUGIN_DOC_DIRS :=
PLUGIN_DISTRIBUTED_LIST:=
PLUGIN_DIST_TARGET_LIST:=
PLUGIN_DIST_DOC_LIST:=
PLUGIN_BIN_DOC_LIST:=
PLUGIN_DIST_EXTERNAL_LIST:=
PLUGIN_TESTS_LIST:=
PLUGIN_DISTRIBUTED_NAME_LIST:=

###############################
# Additional global variables #
###############################

# put here any config option for the binary distribution outside of
# plugins
CONFIG_DISTRIB_BIN:=

# additional compilation targets for 'make all'.
# cannot be delayed after 'make all'
EXTRAS	= ptests

# Directories containing some source code
SRC_DIRS= ptests $(PLUGIN_LIB_DIR)

# Directory containing source code documentation
DOC_DIR	= doc/code

# Source files to document
MODULES_TODOC=

# Directories containing some source code
SRC_DIRS+= $(FRAMAC_SRC_DIRS)

# Directories to include when compiling
INCLUDES=$(addprefix -I , $(FRAMAC_SRC_DIRS)) -I $(PLUGIN_LIB_DIR) -I lib

# Directories to include for ocamldep
INCLUDES_FOR_OCAMLDEP= $(patsubst +%,.,$(INCLUDES) $(GUI_INCLUDES))

# Ocamldep flags
DEP_FLAGS= $(INCLUDES_FOR_OCAMLDEP)

# Files for which dependencies are computed
FILES_FOR_OCAMLDEP+=$(PLUGIN_LIB_DIR)/*.mli \
		$(addsuffix /*.mli, $(UNPACKED_DIRS)) \
		$(addsuffix /*.ml, $(UNPACKED_DIRS))

# Flags to use by ocamlc and ocamlopt
BFLAGS	= $(FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_BYTE)
OFLAGS	= $(FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_OPT)

BLINKFLAGS = $(BFLAGS) -linkall -custom
OLINKFLAGS = $(OFLAGS) -linkall

# Libraries generated by Frama-C
GEN_BYTE_LIBS=
GEN_OPT_LIBS=

# Libraries used in Frama-C
BYTE_LIBS = nums.cma unix.cma bigarray.cma str.cma dynlink.cma \
	$(GEN_BYTE_LIBS)
OPT_LIBS = nums.cmxa unix.cmxa bigarray.cmxa str.cmxa

ifeq ("$(NATIVE_DYNLINK)","yes")
OPT_LIBS+= dynlink.cmxa
endif

OPT_LIBS+= $(GEN_OPT_LIBS)

# files to be included in the distribution.
# plugins may add some files to this list if they include files that are
# not in $PLUGIN_DIR
DISTRIB_FILES:=cil/*/*.ml* cil/src/*/*.ml* cil/*/*.in cil/LICENSE	\
      cil/CHANGES cil/doc/*.html cil/doc/*.tex cil/doc/*.gif		\
      share/frama-c.rc man/frama-c.1 cil/doc/*.pdf cil/doc/api/*.html	\
      cil/doc/examples/*.txt doc/manuals/*.pdf doc/README		\
      doc/code/*.ml* doc/code/*.css doc/code/*.txt			\
      doc/code/toc_head.htm doc/code/toc_tail.htm tests/*/*.c		\
      tests/*/*.h tests/*/*.ml ptests/*.ml*				\
      tests/wp/test_config_dev.system_why				\
      tests/wp/test_config_dev.local_why configure.in Makefile		\
      share/Makefile.plugin configure share/Makefile.dynamic		\
      share/Makefile.dynamic_config.internal				\
      share/Makefile.dynamic_config.external Changelog config.h.in	\
      VERSION $(filter-out CVS,licenses/*) share/*.c share/*.h		\
      share/configure.ac share/Makefile.config.in			\
      share/Makefile.common share/Makefile.plugin			\
      share/Makefile.dynamic 						\
      share/why/*.why share/why/Makefile share/why/*.why.src		\
      $(filter-out %kui%,src/kernel/*.ml*) external/ptmap.ml*		\
      external/unmarshal*.ml* src/ai/*.ml* src/buckx/*.ml*		\
      src/buckx/*.c src/gui/*.ml* src/lib/*.ml* src/logic/*.ml*		\
      src/memory_state/*.ml* src/misc/*.ml* src/project/*.ml*		\
      src/toplevel/*.ml* bin/sed_get_make_major bin/sed_get_make_minor	\
      bin/sed_inplace INSTALL .make-clean .make-clean-stamp		\
      .make-ocamlgraph-stamp

################
# Main targets #
################

ifneq ($(ENABLE_GUI),no)
ifeq ($(HAS_LABLGTK),yes)
EXTRAS	+= gui
endif
endif

all:: byte $(EXTRAS) $(OCAMLBEST) share/Makefile.dynamic_config \
      share/Makefile.kernel
	for plugin in $(EXTERNAL_PLUGINS); do \
	$(MAKE) FRAMAC_LIBDIR=$(FRAMAC_SRC)/lib/fc FRAMAC_SHARE=$(FRAMAC_SRC)/share -C $$plugin all; \
	done

clean::
	$(PRINT_RM) $(OBJ_PERFCOUNT)
	$(RM) $(OBJ_PERFCOUNT)
	for plugin in $(EXTERNAL_PLUGINS); do \
	$(MAKE) FRAMAC_LIBDIR=$(FRAMAC_SRC)/lib/fc FRAMAC_SHARE=$(FRAMAC_SRC)/share -C $$plugin clean; \
	done

.PHONY: top opt byte dist bdist archclean rebuild
top: bin/toplevel.top$(EXE)
byte: bin/toplevel.byte$(EXE)
opt: bin/toplevel.opt$(EXE)

dist: clean
	$(QUIET_MAKE) OPTIM="-unsafe -noassert" DEBUG="" all
bdist: clean
	$(QUIET_MAKE) OPTIM="-unsafe -noassert" DEBUG="" byte

ifneq ("$(OCAMLGRAPH_LOCAL)","")
archclean: clean
	$(PRINT_RM) ocamlgraph
	$(QUIET_MAKE) -C $(OCAMLGRAPH_LOCAL) distclean
	$(PRINT_CONFIG) ocamlgraph
	cd $(OCAMLGRAPH_LOCAL) ; ./configure

rebuild: archclean
	$(PRINT_BUILD) ocamlgraph
	$(MAKE) -C $(OCAMLGRAPH_LOCAL)
	$(PRINT_BUILD) all
	$(QUIET_MAKE) all
else
archclean: clean

rebuild: archclean
	$(PRINT_BUILD) all
	$(QUIET_MAKE) all
endif

############
# Coverage #
############

USE_COVERAGE_TOOL=no
ifeq ($(USE_COVERAGE_TOOL),yes)
COVERAGE_PATH=.
COVERAGE_PREPRO=camlp4o -no_quot -filter $(COVERAGE_PATH)/coverage_filter.cmo
COVERAGE_COMPILER_BYTE=-I $(COVERAGE_PATH) -pp "$(COVERAGE_PREPRO)"
COVERAGE_COMPILER_OPT=-I $(COVERAGE_PATH) -pp "$(COVERAGE_PREPRO)"
COVERAGE_LIB_BYTE=coverage.cma
COVERAGE_LIB_OPT=coverage.cmxa
endif

INCLUDES+=$(COVERAGE_COMPILER_BYTE)
GEN_BYTE_LIBS+=$(COVERAGE_LIB_BYTE)
GEN_OPT_LIBS+=$(COVERAGE_LIB_OPT)
SRC_DIRS+=$(COVERAGE_PATH)

##############
# Ocamlgraph #
##############

ifneq ("$(OCAMLGRAPH_LOCAL)","")

lib/graph.cmi: .make-ocamlgraph $(wildcard $(OCAMLGRAPH_LOCAL)/src/*.ml*) \
		$(OCAMLGRAPH_LOCAL)/Makefile
	$(PRINT_BUILD) ocamlgraph
	$(MAKE) -C $(OCAMLGRAPH_LOCAL)
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@

lib/graph.cmo: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@

lib/graph.cmx: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@

lib/graph.o: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@

GENERATED+= lib/graph.cmo lib/graph.cmi
ifneq ($(OCAMLOPT),no)
GENERATED+= lib/graph.cmx lib/graph.o
endif

GRAPH_BYTE_LIBS=lib/graph.cmo
GRAPH_OPT_LIBS=lib/graph.cmx
GEN_BYTE_LIBS+=$(GRAPH_BYTE_LIBS)
GEN_OPT_LIBS+=$(GRAPH_OPT_LIBS)

.PRECIOUS: .cmo .cmi .cmx .o .cmxa .cma

# viewgraph and  dgraph (included in ocamlgraph)
ifeq ($(HAS_GNOMECANVAS),yes)

lib/viewgraph.cmi: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@

lib/viewgraph.cmo: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@

lib/viewgraph.cmx: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@

lib/viewgraph.o: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@

lib/dgraph.cmi: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@

lib/dgraph.cmo: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@

lib/dgraph.cmx: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@

lib/dgraph.o: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@

GRAPH_GUICMO= lib/dgraph.cmo lib/viewgraph.cmo
GRAPH_GUICMI= $(GRAPH_GUICMO:.cmo=.cmi)
GRAPH_GUICMX= $(GRAPH_GUICMO:.cmo=.cmx)
GRAPH_GUIO=  $(GRAPH_GUICMO:.cmo=.o)
GENERATED+= $(GRAPH_GUICMI) $(GRAPH_GUICMO)
ifneq ($(OCAMLOPT),no)
GENERATED+= $(GRAPH_GUICMX) $(GRAPH_GUIO)
endif

GEN_BYTE_GUI_LIBS+=$(GRAPH_GUICMO)
GEN_OPT_GUI_LIBS+=$(GRAPH_GUICMX)

HAS_VIEWGRAPH=yes
HAS_DGRAPH=yes

else # viewgraph and dgraph are not available
HAS_DGRAPH=no
endif

else # does not use ocamlgraph local version

INCLUDES+=$(OCAMLGRAPH)
BYTE_LIBS+= graph.cma
OPT_LIBS+= graph.cmxa

# viewgraph and dgraph (included in ocamlgraph)
ifeq ($(HAS_GNOMECANVAS),yes)
GRAPH_GUICMO_BASE= dgraph.cmo viewgraph.cmo
GRAPH_GUICMO=$(GRAPH_GUICMO_BASE:%=$(OCAMLGRAPH_HOME)/%)
GRAPH_GUICMX= $(GRAPH_GUICMO:.cmo=.cmx)
GRAPH_GUIO= $(GRAPH_GUICMO:.cmo=.o)
HAS_DGRAPH=yes
else # viewgraph and dgraph not available
HAS_DGRAPH=no
endif

endif # testing ocamlgraph is local

# If 'make untar-ocamlgraph' have to be performed after 'cvs update':
# change '.make-ocamlgraph-stamp' before 'cvs commit'
.make-ocamlgraph: .make-ocamlgraph-stamp
	touch $@
# Inline the rules of "untar-ocamlgraph" here 
# because calling a recursive make does not work
	$(PRINT_UNTAR) ocamlgraph
	$(RM) -r $(OCAMLGRAPH_LOCAL)
	$(TAR) xzf ocamlgraph.tar.gz
	cd $(OCAMLGRAPH_LOCAL) && ./configure

include .make-ocamlgraph
DISTRIB_FILES += .make-ocamlgraph

# force "make untar-ocamlgraph" to be executed for all users of CVS
force-ocamlgraph:
	expr `$(CAT) .make-ocamlgraph-stamp` + 1 > .make-ocamlgraph-stamp

.PHONY: untar-ocamlgraph
untar-ocamlgraph:
	$(PRINT_UNTAR) $@
	$(RM) -r $(OCAMLGRAPH_LOCAL)
	$(TAR) xzf $<
	cd $(OCAMLGRAPH_LOCAL) && ./configure

##################
# Frama-C Kernel #
##################

# Dynlink library
#################

GENERATED += src/lib/dynlink_common_interface.ml

ifeq ($(HAS_OCAML311),yes) # ocaml >= 3.11

ifeq ($(USABLE_NATIVE_DYNLINK),yes) # native dynlink works

src/lib/dynlink_common_interface.ml: src/lib/dynlink_311_or_higher.ml \
		share/Makefile.config Makefile
	$(PRINT_MAKING) $@
	$(CP) $< $@
	$(CHMOD_RO) $@

else # ocaml >= 3.11 but native dynlink doesn't work

ifeq ($(NATIVE_DYNLINK),yes) # native dynlink does exist but doesn't work
