## frama-c 20100401+boron+dfsg

=== Makefile ===
--- 
+++ 
@@ -2,8 +2,9 @@
 #                                                                        #
 #  This file is part of Frama-C.                                         #
 #                                                                        #
-#  Copyright (C) 2007-2009                                               #
-#    CEA   (Commissariat  l'nergie Atomique)                           #
+#  Copyright (C) 2007-2010                                               #
+#    CEA   (Commissariat  l'nergie atomique et aux nergies            #
+#           alternatives)                                                #
 #    INRIA (Institut National de Recherche en Informatique et en         #
 #           Automatique)                                                 #
 #                                                                        #
@@ -23,6 +24,7 @@
 
 # This file is the main makefile of Frama-C.
 
+FRAMAC_SRC=.
 MAKECONFIG_DIR=share
 
 include share/Makefile.common
@@ -33,7 +35,7 @@
 
 # the directory where compiled plugin files are stored
 PLUGIN_LIB_DIR	= lib/plugins
-PLUGIN_GUI_LIB_DIR= lib/gui
+PLUGIN_GUI_LIB_DIR= lib/plugins/gui
 
 # the directory where the other Makefiles are
 FRAMAC_SHARE	= share
@@ -63,7 +65,6 @@
 PLUGIN_DYN_GUI_CMX_LIST :=
 PLUGIN_TYPES_CMO_LIST :=
 PLUGIN_TYPES_CMX_LIST :=
-PLUGIN_GENERATED_LIST :=
 PLUGIN_DEP_LIST:=
 PLUGIN_DOC_LIST :=
 PLUGIN_DOC_DIRS :=
@@ -114,8 +115,10 @@
 		$(addsuffix /*.ml, $(UNPACKED_DIRS))
 
 # Flags to use by ocamlc and ocamlopt
-BFLAGS	= $(FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_BYTE)
-OFLAGS	= $(FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_OPT)
+BFLAGS	= $(FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_BYTE) \
+	  $(OCAMLVIZ_COMPILER_BYTE)
+OFLAGS	= $(FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_OPT) $(GPROFOPT) \
+	  $(OCAMLVIZ_COMPILER_OPT)
 
 BLINKFLAGS = $(BFLAGS) -linkall -custom
 OLINKFLAGS = $(OFLAGS) -linkall
@@ -135,33 +138,41 @@
 
 OPT_LIBS+= $(GEN_OPT_LIBS)
 
-# files to be included in the distribution.
-# plugins may add some files to this list if they include files that are
-# not in $PLUGIN_DIR
+# Kernel files to be included in the distribution.
+# Plug-ins should use PLUGIN_DISTRIB_EXTERNAL if they export something else
+# than *.ml* files in their directory.
+# NB: configure for the distribution is generated in the distrib directory
+# itself, rather than copied: otherwise, it could include references to
+# non-distributed plug-ins.
 DISTRIB_FILES:=cil/*/*.ml* cil/src/*/*.ml* cil/*/*.in cil/LICENSE	\
       cil/CHANGES cil/doc/*.html cil/doc/*.tex cil/doc/*.gif		\
       share/frama-c.rc man/frama-c.1 cil/doc/*.pdf cil/doc/api/*.html	\
       cil/doc/examples/*.txt doc/manuals/*.pdf doc/README		\
       doc/code/*.ml* doc/code/*.css doc/code/*.txt			\
-      doc/code/toc_head.htm doc/code/toc_tail.htm tests/*/*.c		\
-      tests/*/*.h tests/*/*.ml ptests/*.ml*				\
-      tests/wp/test_config_dev.system_why				\
-      tests/wp/test_config_dev.local_why configure.in Makefile		\
-      share/Makefile.plugin configure share/Makefile.dynamic		\
-      share/Makefile.dynamic_config.internal				\
+      doc/code/toc_head.htm doc/code/toc_tail.htm 			\
+      share/frama-c.ico share/frama-c.gif				\
+      tests/*/*.c tests/*/*.h tests/*/*.ml ptests/*.ml* configure.in	\
+      Makefile share/Makefile.kernel share/Makefile.plugin		\
+      share/Makefile.dynamic share/Makefile.dynamic_config.internal	\
       share/Makefile.dynamic_config.external Changelog config.h.in	\
-      VERSION $(filter-out CVS,licenses/*) share/*.c share/*.h		\
+      VERSION $(filter-out CVS,licenses/*)              		\
+      share/*.c share/*.h share/libc/*.c share/libc/*.h                 \
+      share/libc/sys/*.h share/libc/netinet/*.h                         \
+      share/acsl.el share/frama-c.gif share/frama-c.ico                 \
+      share/known_plugins.ac                                            \
       share/configure.ac share/Makefile.config.in			\
       share/Makefile.common share/Makefile.plugin			\
-      share/Makefile.dynamic 						\
-      share/why/*.why share/why/Makefile share/why/*.why.src		\
-      $(filter-out %kui%,src/kernel/*.ml*) external/ptmap.ml*		\
-      external/unmarshal*.ml* src/ai/*.ml* src/buckx/*.ml*		\
-      src/buckx/*.c src/gui/*.ml* src/lib/*.ml* src/logic/*.ml*		\
-      src/memory_state/*.ml* src/misc/*.ml* src/project/*.ml*		\
-      src/toplevel/*.ml* bin/sed_get_make_major bin/sed_get_make_minor	\
-      bin/sed_inplace INSTALL .make-clean .make-clean-stamp		\
-      .make-ocamlgraph-stamp
+      share/Makefile.dynamic share/why/*.why share/why/Makefile		\
+      share/Makefile.dynamic_config.external                            \
+      share/Makefile.dynamic_config.internal                            \
+      share/why/*.why share/why/Makefile                 		\
+      share/why/*.why.src $(filter-out %kui%,src/kernel/*.ml*)		\
+      external/ptmap.ml* external/unmarshal*.ml* src/ai/*.ml*		\
+      src/buckx/*.ml* src/buckx/*.c src/gui/*.ml* src/lib/*.ml*		\
+      src/logic/*.ml* src/memory_state/*.ml* src/misc/*.ml*		\
+      src/project/*.ml* src/toplevel/*.ml* bin/sed_get_make_major	\
+      bin/sed_get_make_minor bin/sed_inplace INSTALL INSTALL_WITH_WHY	\
+      .make-clean .make-clean-stamp .make-ocamlgraph-stamp
 
 ################
 # Main targets #
@@ -173,46 +184,41 @@
 endif
 endif
 
-all:: byte $(EXTRAS) $(OCAMLBEST) share/Makefile.dynamic_config \
-      share/Makefile.kernel
-	for plugin in $(EXTERNAL_PLUGINS); do \
-	$(MAKE) FRAMAC_LIBDIR=$(FRAMAC_SRC)/lib/fc FRAMAC_SHARE=$(FRAMAC_SRC)/share -C $$plugin all; \
-	done
+all:: byte $(EXTRAS) $(OCAMLBEST)
 
 clean::
 	$(PRINT_RM) $(OBJ_PERFCOUNT)
 	$(RM) $(OBJ_PERFCOUNT)
-	for plugin in $(EXTERNAL_PLUGINS); do \
-	$(MAKE) FRAMAC_LIBDIR=$(FRAMAC_SRC)/lib/fc FRAMAC_SHARE=$(FRAMAC_SRC)/share -C $$plugin clean; \
-	done
 
 .PHONY: top opt byte dist bdist archclean rebuild
 top: bin/toplevel.top$(EXE)
-byte: bin/toplevel.byte$(EXE)
-opt: bin/toplevel.opt$(EXE)
+
+byte:: bin/toplevel.byte$(EXE) \
+      share/Makefile.dynamic_config share/Makefile.kernel
+	$(MAKE) install-kernel-byte FRAMAC_LIBDIR=lib/fc
+
+opt:: bin/toplevel.opt$(EXE) \
+     share/Makefile.dynamic_config share/Makefile.kernel
+	$(MAKE) install-kernel-opt FRAMAC_LIBDIR=lib/fc
 
 dist: clean
 	$(QUIET_MAKE) OPTIM="-unsafe -noassert" DEBUG="" all
+
 bdist: clean
 	$(QUIET_MAKE) OPTIM="-unsafe -noassert" DEBUG="" byte
 
 ifneq ("$(OCAMLGRAPH_LOCAL)","")
 archclean: clean
-	$(PRINT_RM) ocamlgraph
-	$(QUIET_MAKE) -C $(OCAMLGRAPH_LOCAL) distclean
-	$(PRINT_CONFIG) ocamlgraph
+	$(MAKE) -C $(OCAMLGRAPH_LOCAL) distclean
 	cd $(OCAMLGRAPH_LOCAL) ; ./configure
 
 rebuild: archclean
-	$(PRINT_BUILD) ocamlgraph
 	$(MAKE) -C $(OCAMLGRAPH_LOCAL)
-	$(PRINT_BUILD) all
 	$(QUIET_MAKE) all
 else
 archclean: clean
 
 rebuild: archclean
-	$(PRINT_BUILD) all
 	$(QUIET_MAKE) all
 endif
 
@@ -235,6 +241,32 @@
 GEN_OPT_LIBS+=$(COVERAGE_LIB_OPT)
 SRC_DIRS+=$(COVERAGE_PATH)
 
+########################
+# Ocamlviz (profiling) #
+########################
+
+# To use OCamlviz you need to fix its makefile :-(
+# In $(OCAMLVIZ_PATH)/Makefile.in change the line
+# OCAMLVIZCMO = $(PROTOCOLCMO) src/monitor_impl.cmo src/ocamlviz.cmo src/ocamlviz_threads.cmo
+# into
+# OCAMLVIZCMO = $(PROTOCOLCMO) src/monitor_impl.cmo src/ocamlviz.cmo
+# Then run "./configure && make" in $(OCAMLVIZ_PATH)
+# You need to set $(OCAMLVIZ_PATH) according to your own setup.
+# Only one instance of Frama-C can be launched at a time when Ocamlviz is on.
+USE_OCAMLVIZ_TOOL=no
+ifeq ($(USE_OCAMLVIZ_TOOL),yes)
+OCAMLVIZ_PATH=EXTERNAL/ocamlviz
+OCAMLVIZ_COMPILER_BYTE=-I $(OCAMLVIZ_PATH)/src
+# -pp "camlp4 pa_o.cmo str.cma $(OCAMLVIZ_PATH)/camlp4/pa_ocamlviz.cmo pr_o.cmo"
+# Seems really broken and generates fatal warnings
+OCAMLVIZ_COMPILER_OPT=-I $(OCAMLVIZ_PATH)/src
+OCAMLVIZ_LIB_BYTE=$(OCAMLVIZ_PATH)/libocamlviz.cma
+OCAMLVIZ_LIB_OPT=$(OCAMLVIZ_PATH)/libocamlviz.cmxa
+endif
+
+BYTE_LIBS+=$(OCAMLVIZ_LIB_BYTE)
+OPT_LIBS+=$(OCAMLVIZ_LIB_OPT)
+
 ##############
 # Ocamlgraph #
 ##############
@@ -334,61 +366,3 @@
 
 # viewgraph and dgraph (included in ocamlgraph)
 ifeq ($(HAS_GNOMECANVAS),yes)
-GRAPH_GUICMO_BASE= dgraph.cmo viewgraph.cmo
-GRAPH_GUICMO=$(GRAPH_GUICMO_BASE:%=$(OCAMLGRAPH_HOME)/%)
-GRAPH_GUICMX= $(GRAPH_GUICMO:.cmo=.cmx)
-GRAPH_GUIO= $(GRAPH_GUICMO:.cmo=.o)
-HAS_DGRAPH=yes
-else # viewgraph and dgraph not available
-HAS_DGRAPH=no
-endif
-
-endif # testing ocamlgraph is local
-
-# If 'make untar-ocamlgraph' have to be performed after 'cvs update':
-# change '.make-ocamlgraph-stamp' before 'cvs commit'
-.make-ocamlgraph: .make-ocamlgraph-stamp
-	touch $@
-# Inline the rules of "untar-ocamlgraph" here 
-# because calling a recursive make does not work
-	$(PRINT_UNTAR) ocamlgraph
-	$(RM) -r $(OCAMLGRAPH_LOCAL)
-	$(TAR) xzf ocamlgraph.tar.gz
-	cd $(OCAMLGRAPH_LOCAL) && ./configure
-
-include .make-ocamlgraph
-DISTRIB_FILES += .make-ocamlgraph
-
-# force "make untar-ocamlgraph" to be executed for all users of CVS
-force-ocamlgraph:
-	expr `$(CAT) .make-ocamlgraph-stamp` + 1 > .make-ocamlgraph-stamp
-
-.PHONY: untar-ocamlgraph
-untar-ocamlgraph:
-	$(PRINT_UNTAR) $@
-	$(RM) -r $(OCAMLGRAPH_LOCAL)
-	$(TAR) xzf $<
-	cd $(OCAMLGRAPH_LOCAL) && ./configure
-
-##################
-# Frama-C Kernel #
-##################
-
-# Dynlink library
-#################
-
-GENERATED += src/lib/dynlink_common_interface.ml
-
-ifeq ($(HAS_OCAML311),yes) # ocaml >= 3.11
-
-ifeq ($(USABLE_NATIVE_DYNLINK),yes) # native dynlink works
-
-src/lib/dynlink_common_interface.ml: src/lib/dynlink_311_or_higher.ml \
-		share/Makefile.config Makefile
-	$(PRINT_MAKING) $@
-	$(CP) $< $@
-	$(CHMOD_RO) $@
-
-else # ocaml >= 3.11 but native dynlink doesn't work
-
-ifeq ($(NATIVE_DYNLINK),yes) # native dynlink does exist but doesn't work
