=== share/why/Makefile ===
--- 
+++ 
@@ -1,3 +1,27 @@
+##########################################################################
+#                                                                        #
+#  This file is part of Frama-C.                                         #
+#                                                                        #
+#  Copyright (C) 2007-2010                                               #
+#    CEA   (Commissariat  l'nergie atomique et aux nergies            #
+#           alternatives)                                                #
+#    INRIA (Institut National de Recherche en Informatique et en         #
+#           Automatique)                                                 #
+#                                                                        #
+#  you can redistribute it and/or modify it under the terms of the GNU   #
+#  Lesser General Public License as published by the Free Software       #
+#  Foundation, version 2.1.                                              #
+#                                                                        #
+#  It is distributed in the hope that it will be useful,                 #
+#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
+#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
+#  GNU Lesser General Public License for more details.                   #
+#                                                                        #
+#  See the GNU Lesser General Public License version v2.1                #
+#  for more details (enclosed in the file licenses/LGPLv2.1).            #
+#                                                                        #
+##########################################################################
+
 # This Makefile build why model files because it seems that [why]
 # looks for included files only in its installation directory.
 # So, a workaround is to simulate inclusion.
