=== src/dummy/hello_world/Makefile ===
--- 
+++ 
@@ -2,8 +2,9 @@
 #                                                                        #
 #  This file is part of Frama-C.                                         #
 #                                                                        #
-#  Copyright (C) 2007-2009                                               #
-#    CEA (Commissariat  l'nergie Atomique)                             #
+#  Copyright (C) 2007-2010                                               #
+#    CEA (Commissariat  l'nergie atomique et aux nergies              #
+#         alternatives)                                                  #
 #                                                                        #
 #  you can redistribute it and/or modify it under the terms of the GNU   #
 #  Lesser General Public License as published by the Free Software       #
@@ -25,8 +26,8 @@
 # Frama-c should be properly installed with "make install" 
 # before any use of this makefile
 
-FRAMAC_SHARE=$(shell frama-c.byte -print-path)
-FRAMAC_LIBDIR=$(shell frama-c.byte -print-libpath)
-PLUGIN_NAME=Hello
-PLUGIN_CMO=hello_world
+FRAMAC_SHARE  	:=$(shell frama-c.byte -print-path)
+FRAMAC_LIBDIR 	:=$(shell frama-c.byte -print-libpath)
+PLUGIN_NAME	= Hello
+PLUGIN_CMO	= hello_world
 include $(FRAMAC_SHARE)/Makefile.dynamic
