=== src/dummy/untyped_metrics/Makefile ===
--- 
+++ 
@@ -2,8 +2,9 @@
 #                                                                        #
 #  This file is part of Frama-C.                                         #
 #                                                                        #
-#  Copyright (C) 2007-2009                                               #
-#    CEA (Commissariat  l'nergie Atomique)                             #
+#  Copyright (C) 2007-2010                                               #
+#    CEA (Commissariat  l'nergie atomique et aux nergies              #
+#         alternatives)                                                  #
 #                                                                        #
 #  you can redistribute it and/or modify it under the terms of the GNU   #
 #  Lesser General Public License as published by the Free Software       #
