=== debian/changelog ===
frama-c (20100401+boron+dfsg-5) unstable; urgency=low

  [ Stéphane Glondu ]
  * Fix versioned build-deps to ensure smoother backports

  [ Mehdi Dogguy ]
  * Add 0011-Fix-some-minor-memory-leaks.patch

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 05 Oct 2010 18:49:13 +0200

frama-c (20100401+boron+dfsg-4) unstable; urgency=low

  * Add 0009-unrollType-in-handle_signed_overflow from upstream.
  * Add 0010-More-spelling-fixes.patch
  * Convert to 3.0 (quilt) source format.
  * Bump standards version to 3.9.0.

 -- Mehdi Dogguy <mehdi@debian.org>  Fri, 16 Jul 2010 13:53:55 +0200

frama-c (20100401+boron+dfsg-3) unstable; urgency=low

  * Add some patches
    - 0007-Fix-cpp-command-arguments.patch
    - 0008-Fix-ai-ival.ml-filter_ge.patch

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 14 Jun 2010 23:36:37 +0200

frama-c (20100401+boron+dfsg-2) unstable; urgency=low

  * Make the configure script accept OCamlgraph 1.5 (Closes: #580090)
  * Build-depend on ocaml (>= 3.11.1-3~) and dh-ocaml (>= 0.9~).
  * Add a debian/source/format file (keep the package in 1.0 format,
    for now).

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 01 Jun 2010 20:18:44 +0200

frama-c (20100401+boron+dfsg-1) unstable; urgency=low

  * New upstream release:
    - Remove some patches integrated by upstream:
      + 0001-Use-GSourceView2.patch
      + 0003-Do-not-install-native-Kernel-modules-on-bytecode-arc.patch
      + 0004-temp_file-changed-in-OCaml-3.11.2.patch
    - Add some patches:
      + 0002-.make-ocamlgraph-no-op-for-non-local-ocamlgraph
      + 0003-Fix-build-on-bytecode-only-architectures.patch
      + 0004-Fix-some-typos.patch
      + 0005-Don-t-modify-system-files.patch
      + 0006-Fix-build-on-bytecode-only-architectures.patch
    - Update:
      + 0001-Fix-hyphen-used-as-minus-sign-and-a-typo.patch
    - Bump ocamlgraph minimum version to 1.4
  * Set Priority to optional
  * Set filter-pristine-tar in debian/gbp.conf
  * Fix watch file
  * Update 'Homepage' field
  * Bump Standards Version to 3.8.4, no changes needed.
  * Update copyright file

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 27 Apr 2010 16:04:49 +0200

frama-c (20090902+beryllium+dfsg-5) unstable; urgency=low

  * Build-Depend on libocamlgraph-viewer-ocaml-dev (Closes: #575371)

 -- Mehdi Dogguy <mehdi@debian.org>  Thu, 25 Mar 2010 11:14:43 +0100

frama-c (20090902+beryllium+dfsg-4) unstable; urgency=low

  * Make it compile with OCaml 3.11.2 (Closes: #569260)
    - Add 0004-temp_file-changed-in-OCaml-3.11.2.patch

 -- Mehdi Dogguy <mehdi@debian.org>  Thu, 11 Feb 2010 20:57:17 +0100

frama-c (20090902+beryllium+dfsg-3) unstable; urgency=low

  * Fix FTBFS on bytecode architectures
    - 0003-Do-not-install-native-Kernel-modules-on-bytecode-architectures
  * Add Graphviz to build-depends

 -- Mehdi Dogguy <mehdi@debian.org>  Fri, 22 Jan 2010 11:59:37 +0100

frama-c (20090902+beryllium+dfsg-2) unstable; urgency=low

  * Fix installability problem by installing frama-c-gui.1 only once.
  * Remove empty dirs
  * Fix hyphen-used-as-minus-sign
  * Fix short description of frama-c-base
  * Set section to « devel »

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 17 Jan 2010 19:33:00 +0100

frama-c (20090902+beryllium+dfsg-1) unstable; urgency=low

  * New upstream release
    + Remove 0001-Fix-weak-pattern-matching-in-dynlink_lower_311_byte..patch
      (fixed upstream)
    + Remove 0003-Add-dGraphView.cmo-when-linking.patch (fixed upstream)
  * Update copyright file
  * Remove libjessie-ocaml-dev from build-deps (Why is not needed anymore
    to build Frama-C).
  * Run dh using "--with ocaml" to trigger dh-ocaml sequence
  * Build-depend on ocamlgraph 1.3
  * Add a new binary package: frama-c-base

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 10 Jan 2010 22:50:18 +0100

frama-c (20090901+beryllium+dfsg-2) unstable; urgency=low

  * Fix watch file
  * Build-depend on lablgtk2 (>= 2.14.0+dfsg-2) (Closes: #541963).
    - Add a patch: 0004-Use-GSourceView2.patch
  * Use new features of dh-ocaml
  * Build-dep on ocamlgraph (>> 1.2+debian)

 -- Mehdi Dogguy <mehdi@debian.org>  Wed, 02 Dec 2009 00:08:35 +0100

frama-c (20090901+beryllium+dfsg-1) unstable; urgency=low

  * Change the version number to reflect the codename in the version string
  * New Upstream Version
    + Fixes the issues related the static Jessie plugin. Thus, removing:
      0004-Add-JCCM-O-X-to-BYTE-OPT-_LIBS-when-linking-statical.patch
      (Closes: #544404).
    + Provides toc_head.htm and toc_tail.htm
    + Fixes linking problem for the viewer. Thus, removing:
      0002-Do-not-add-GRAPH_GUICMO-to-BYTE_GUI_LIBS.patch
    + Removing 0006-Do-not-install-non-existant-files.patch (now integrated
      upstream)
  * Add some patches:
    + Fix weak pattern-matching in dynlink_lower_311_byte.ml, fixes FTBFS
      on non-native architectures (Closes: #544833).
      0001-Fix-weak-pattern-matching-in-dynlink_lower_311_byte..patch
    + Make the Jessie plugin compile with Jc 2.19:
      0002-Make-Jessie-plugin-use-Jc-from-Why-2.19.patch
    + Fix linking problem for the viewer (add dGraphView.cmo):
      0003-Add-dGraphView.cmo-when-linking.patch
  * Bump libocamlgraph-ocaml-dev version from 1.1 to 1.2+debian in build
    dependencies.
  * Don't strip bytecode binaries since they are compiled with -custom
  * Recommends alt-ergo and libwhy-coq
  * Remove useless runtime dependency libocamlgraph-ocaml-dev
  * Install data needed by frama-c in /usr/share/frama-c
  * Make some additional links to follow default upstream installation:
    + /usr/share/frama-c/why      -> /usr/share/why/
    + /usr/share/frama-c/caduceus -> /usr/share/caduceus

 -- Mehdi Dogguy <mehdi@debian.org>  Wed, 09 Sep 2009 17:30:41 +0200

frama-c (20090601~beta1+dfsg-1) unstable; urgency=low

  * New Upstream Version
  * Use Debian mail address, Remove DMUA
  * Remove patches integrated upstream:
    + 0001-Gui_includes-variable-should-include-ocamlgraph-too.patch
    + 0002-Make-the-jessie-plugin-compatible-with-why-2.18.patch

